/*+~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~+
  | Indicator for showing up to 7 of your favorite MAs against price in        |
  | seperate window to clean up chart      Copyright  2006, Accrete LLC       |
  |                                          http://www.accrete.com            |
  | For further information on the Accrete Trading Model",                     |
  | visit the web at www.accrete.com/fx-atm . There you will find various      |
  | links, trade examples, and the latest updates on the model by Accrete      |
  | Place this file in the experts>indicators folder. Once on the chart move   |
  | to another time frame, and the labels will set properly. You may now go to |
  | your preferred time frame and have your favorite MAs and Trends in a nice  |
  | layout below the main charting window.                                     |
  | This hack was to add 5 additional MAs and Trend Labels used in the ATM.    |
  | Also, in addition to the ability to show 7 moving averages, you will note  |
  | in the indicator window the lables for 3 "Trends". Each of the three trend |
  | label-names will change according to the color of the moving average they  |
  | represent. As the price moves above the MA, a blue "UP" will appear to the |
  | right of the label. Price below the MA is indicated in a red "DN". On the  |
  | "Main" trend there is also the feature of a caution indicator that will    |
  | show as a yellow "ZZ"...time to take a nap, chill out or just read a few   |
  | pages out of your favorite trading book/blog/forum : )                     |
  | MA5 amd MA6 are defaulted to the High and Low of the "LongTrendMA" as i    |
  | like to have a tunnel off the 144 (the defaul of the LTMA). But all        |
  | parameters of each MA are available, so you can change the setting to suit |
  | your model.                                                                |
  | Have fun with this indicator. I created it mainly to clear up my chart and |
  | allow a quick glance for a heads up on some trends i follow according to   |
  | my studies with the Vegas models and also GANN Squares/Wheel:(6/12/24/144) |
  | One other feature is the "TimeFrame" property. If set to the default of "0"|
  | the indicator will show the trends on the selected time frame. If one      |
  | wishes to show a particular trend, say the 60m trend, the place "60" in    |
  | the property. Then if you go to any other time frame you will see the 60m  |
  | chart's trends.                                                            |
  | Cheers, Accrete        accrete.com                                         |                                      
  +~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~><>~~~~~~~~~~~~~~~~~~~~~~+
*/
//+----------------------------------------------------------------------------+
//|      original code with two moving averages and price by PriceTrender2.mq4 |
//|                                                          Kalenzo           |
//|                                                bartlomiej.gorski@gmail.com |
//+----------------------------------------------------------------------------+
#property copyright "Accrete"
#property link      "accrete.com"
#property indicator_buffers 8
#property indicator_color1 Black
#property indicator_color2 Red
#property indicator_color3 Magenta
#property indicator_color4 Magenta
#property indicator_color5 Magenta
#property indicator_color6 Gold
#property indicator_color7 Aqua
#property indicator_color8 Lime
extern bool Comments=false;
extern int TimeFrame = 60,
           Price = 0,
           LongTrendMaType = 1,
           LongTrendMaPrice = 0,
           LongTrendMaLength = 144, 
           MainTrendMaType = 1,
           MainTrendMaPrice = 0,
           MainTrendMaLength = 24,
           MiniTrendMaType = 1,
           MiniTrendMaPrice = 0,
           MiniTrendMaLength = 6,
           VeryLongMaType = 1,
           VeryLongMaPrice = 0,
           VeryLongMaLength = 363,
           Ma5Type = 1,
           Ma5Price = 2,
           Ma5Length = 144,
           Ma6Type = 1,
           Ma6Price = 3,
           Ma6Length = 144,          
           DotMaType = 1,
           DotMaPrice = 0,
           DotMaLength = 12;
double D = 1; //How many days back /0 = curr day/ 1 = yesterday/ 2= 2days ago
double B = 0; //Today = 0/ yesterday = 1 / 2days ago = 2
double price[],longtrend[],trend[],trend2[],mavltf[],ma5[],ma6[],madot[];
 
#property indicator_separate_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
IndicatorShortName("ATM_PriceTrend7mma");
//---- indicators
SetIndexBuffer(0,price);
SetIndexBuffer(1,mavltf);
SetIndexBuffer(2,longtrend);
SetIndexBuffer(3,ma5);
SetIndexBuffer(4,ma6);
SetIndexBuffer(5,trend);
SetIndexBuffer(6,trend2);
SetIndexBuffer(7,madot);

SetIndexStyle(0,DRAW_LINE,0,3);
SetIndexStyle(1,DRAW_LINE,0,1);
SetIndexStyle(2,DRAW_LINE,0,2);
SetIndexStyle(3,DRAW_LINE,2,0);
SetIndexStyle(4,DRAW_LINE,2,0);
SetIndexStyle(5,DRAW_LINE,0,2);
SetIndexStyle(6,DRAW_LINE,0,2);
SetIndexStyle(7,DRAW_ARROW,0,2);
SetIndexArrow(7,160);
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    limit, bigshift; 
   int    counted_bars=IndicatorCounted(); 
//---- 
   if (counted_bars<0) return(-1); 
   if (counted_bars>0) counted_bars--; 
   limit=Bars-counted_bars; 
    
   for (int i=limit; i>=0; i--)

   { 
      bigshift = iBarShift(Symbol(),TimeFrame,Time[i]); 
      
       price[i] = getPrice(bigshift);
       mavltf[i] = iMA(Symbol(),TimeFrame,VeryLongMaLength,0,VeryLongMaType,VeryLongMaPrice,bigshift);
       
       longtrend[i] = iMA(Symbol(),TimeFrame,LongTrendMaLength,0,LongTrendMaType,LongTrendMaPrice,bigshift);
       ma5[i] = iMA(Symbol(),TimeFrame,Ma5Length,0,Ma5Type,Ma5Price,bigshift);
       ma6[i] = iMA(Symbol(),TimeFrame,Ma6Length,0,Ma6Type,Ma6Price,bigshift);
       
       trend[i] = iMA(Symbol(),TimeFrame,MainTrendMaLength,0,MainTrendMaType,MainTrendMaPrice,bigshift);
       trend2[i] = iMA(Symbol(),TimeFrame,MiniTrendMaLength,0,MiniTrendMaType,MiniTrendMaPrice,bigshift); 
       madot[i] = iMA(Symbol(),TimeFrame,DotMaLength,0,DotMaType,DotMaPrice,bigshift);
  
   string ENTRY_trend2= "",entry_mavltf= "",ENTRY_mavltf= "",entry_trend2= "",WAIT_price= "",wait_price= "",MINI= "",
          mini= "";
   
   //Trend UP/DOWN
   
     if ((price[i]> mavltf[i])&& (trend[i]> mavltf[i])) {entry_mavltf= "UP"; }
     if ((price[i]< mavltf[i])&& (trend[i]< mavltf[i])) {ENTRY_mavltf= "DN"; }
     
     if ((price[i]> trend[i])&& (trend2[i]> trend[i])) {entry_trend2= "UP"; }
     if ((price[i]< trend[i])&& (trend2[i]< trend[i])) {ENTRY_trend2= "DN"; }
     
     if ((price[i]< trend[i])&& (trend2[i]> trend[i])) {WAIT_price= "ZZ"; }
     if ((price[i]> trend[i])&& (trend2[i]< trend[i])) {wait_price= "ZZ"; }
     
     if (price[i]> trend2[i]) {MINI= "UP";}
     if (price[i]< trend2[i]) {mini= "DN";}
 

    ObjectCreate("lab4", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND LABEL
        ObjectSetText("lab4","TRENDS :", 10, "Arial Bold", White);
        ObjectSet("lab4", OBJPROP_CORNER, 0);
        ObjectSet("lab4", OBJPROP_XDISTANCE, 10);
        ObjectSet("lab4", OBJPROP_YDISTANCE, 15);

//wait label for major trend        
   ObjectCreate("major-trend-lab", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND LABEL
        ObjectSetText("major-trend-lab","MAJOR = ", 10, "Arial Bold", indicator_color3);
        ObjectSet("major-trend-lab", OBJPROP_CORNER, 0);
        ObjectSet("major-trend-lab", OBJPROP_XDISTANCE, 75);
        ObjectSet("major-trend-lab", OBJPROP_YDISTANCE, 15);
        
        ObjectCreate("mavltf-U", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND UP
        ObjectSetText("mavltf-U",StringSubstr(entry_mavltf,0),10, "Arial Bold", Blue);
        ObjectSet("mavltf-U", OBJPROP_CORNER, 0);
        ObjectSet("mavltf-U", OBJPROP_XDISTANCE, 140);//was 250
        ObjectSet("mavltf-U", OBJPROP_YDISTANCE, 15);//was 15
        ObjectCreate("mavltf-D", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND DOWN
        ObjectSetText("mavltf-D",StringSubstr(ENTRY_mavltf,0),10, "Arial Bold", Red);
        ObjectSet("mavltf-D", OBJPROP_CORNER, 0);
        ObjectSet("mavltf-D", OBJPROP_XDISTANCE, 140);//was 250
        ObjectSet("mavltf-D", OBJPROP_YDISTANCE, 15);//was 15
        
//wait label for main trend        
   ObjectCreate("main-trend-lab", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND LABEL
        ObjectSetText("main-trend-lab","MAIN = ", 10, "Arial Bold", indicator_color6);
        ObjectSet("main-trend-lab", OBJPROP_CORNER, 0);
        ObjectSet("main-trend-lab", OBJPROP_XDISTANCE, 180);
        ObjectSet("main-trend-lab", OBJPROP_YDISTANCE, 15);
        
   
        ObjectCreate("ESIG2", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND UP
        ObjectSetText("ESIG2",StringSubstr(entry_trend2,0),10, "Arial Bold", Blue);
        ObjectSet("ESIG2", OBJPROP_CORNER, 0);
        ObjectSet("ESIG2", OBJPROP_XDISTANCE, 230);//was 250
        ObjectSet("ESIG2", OBJPROP_YDISTANCE, 15);//was 15
        ObjectCreate("ESIG3", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND DOWN
        ObjectSetText("ESIG3",StringSubstr(ENTRY_trend2,0),10, "Arial Bold", Red);
        ObjectSet("ESIG3", OBJPROP_CORNER, 0);
        ObjectSet("ESIG3", OBJPROP_XDISTANCE, 230);//was 250
        ObjectSet("ESIG3", OBJPROP_YDISTANCE, 15);//was 15
        
//wait label for main trend when in caution zone:     
        ObjectCreate("ESIG4", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//WAIT
        ObjectSetText("ESIG4",StringSubstr(WAIT_price,0),10, "Arial Bold", Yellow);
        ObjectSet("ESIG4", OBJPROP_CORNER, 0);
        ObjectSet("ESIG4", OBJPROP_XDISTANCE, 230);//was 263
        ObjectSet("ESIG4", OBJPROP_YDISTANCE, 15);//was 15
        ObjectCreate("ESIG5", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//WAIT
        ObjectSetText("ESIG5",StringSubstr(wait_price,0),10, "Arial Bold", Yellow);
        ObjectSet("ESIG5", OBJPROP_CORNER, 0);
        ObjectSet("ESIG5", OBJPROP_XDISTANCE, 230);//was 263
        ObjectSet("ESIG5", OBJPROP_YDISTANCE, 15);//was  15    
        
//wait label for mini trend
  ObjectCreate("mini-trend-lab", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//TREND LABEL
        ObjectSetText("mini-trend-lab","MINI = ", 10, "Arial Bold", indicator_color7);
        ObjectSet("mini-trend-lab", OBJPROP_CORNER, 0);
        ObjectSet("mini-trend-lab", OBJPROP_XDISTANCE, 270);
        ObjectSet("mini-trend-lab", OBJPROP_YDISTANCE, 15);
              
        ObjectCreate("ESIG6", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//Mini UP
        ObjectSetText("ESIG6",StringSubstr(MINI,0),10, "Arial Bold", Blue);
        ObjectSet("ESIG6", OBJPROP_CORNER, 0);
        ObjectSet("ESIG6", OBJPROP_XDISTANCE, 315);//was 253
        ObjectSet("ESIG6", OBJPROP_YDISTANCE, 15);//was 45
        ObjectCreate("ESIG7", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//Mini DOWN
        ObjectSetText("ESIG7",StringSubstr(mini,0),10, "Arial Bold", Red);
        ObjectSet("ESIG7", OBJPROP_CORNER, 0);
        ObjectSet("ESIG7", OBJPROP_XDISTANCE, 315);//was 253
        ObjectSet("ESIG7", OBJPROP_YDISTANCE, 15);//was 45 
        
        // ----insert for showing high low data   
double HDAILY = iMA(Symbol(),PERIOD_D1,1,0,MODE_HIGH,PRICE_HIGH,B);
double LDAILY = iMA(Symbol(),PERIOD_D1,1,0,MODE_LOW,PRICE_LOW,B); 
  
//  CreateObj(HDAILY, LDAILY);

   ObjectCreate("hightxt", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//HiLow LABEL
        ObjectSetText("hightxt","H@", 13, "Arial Bold", White);
        ObjectSet("hightxt", OBJPROP_CORNER, 0);
        ObjectSet("hightxt", OBJPROP_XDISTANCE, 350);
        ObjectSet("hightxt", OBJPROP_YDISTANCE, 10);
 
  ObjectCreate("high", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);
        ObjectSetText("high",DoubleToStr(HDAILY,Digits), 13, "Arial Bold", Blue);
        ObjectSet("high", OBJPROP_CORNER, 0);
        ObjectSet("high", OBJPROP_XDISTANCE, 385);
        ObjectSet("high", OBJPROP_YDISTANCE, 10);
        
  ObjectCreate("lowtxt", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);//HiLow LABEL
        ObjectSetText("lowtxt","L@", 13, "Arial Bold", White);
        ObjectSet("lowtxt", OBJPROP_CORNER, 0);
        ObjectSet("lowtxt", OBJPROP_XDISTANCE, 450);
        ObjectSet("lowtxt", OBJPROP_YDISTANCE, 10);
        
  ObjectCreate("low", OBJ_LABEL, WindowFind("ATM_PriceTrend7mma"), 0, 0);
        ObjectSetText("low",DoubleToStr(LDAILY,Digits), 13, "Arial Bold", Red);
        ObjectSet("low", OBJPROP_CORNER, 0);
        ObjectSet("low", OBJPROP_XDISTANCE, 485);
        ObjectSet("low", OBJPROP_YDISTANCE, 10);      
//-----insert end of line.             
   
   } 

//----
 
   return(0);
  }
//+------------------------------------------------------------------+
double getPrice(int shift)
{
   switch(Price)
   {
      case 0 : return ( iClose(Symbol(),TimeFrame,shift) );
      case 1 : return (iOpen(Symbol(),TimeFrame,shift));
      case 2 : return (iHigh(Symbol(),TimeFrame,shift));
      case 3 : return (iLow(Symbol(),TimeFrame,shift));
      case 4 : return ((iLow(Symbol(),TimeFrame,shift)+iHigh(Symbol(),TimeFrame,shift))/2);
      case 5 : return ((iClose(Symbol(),TimeFrame,shift)+iLow(Symbol(),TimeFrame,shift)+iHigh(Symbol(),TimeFrame,shift))/3);
      case 6 : return ((iOpen(Symbol(),TimeFrame,shift)+iClose(Symbol(),TimeFrame,shift)+iLow(Symbol(),TimeFrame,shift)+iHigh(Symbol(),TimeFrame,shift))/4);
   }
   
   
   
   
   
}